class AST::Identifier
  attr_reader :name

  def initialize(name)
    @name = name
  end

  def ==(other)
    other.is_a?(AST::Identifier) && other.name == @name
  end

  def execute(env)
    value = env.get(@name)

    value.respond_to?(:execute) ? value.execute(env) : value
  end
end
